using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GroupDropFormatting
{
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(32, 32);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(720, 472);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.50";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(784, 518);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			# region  [   Binding GridGroupingControl With DataTable  ]
			this.gridGroupingControl1.TableModel.Options.WrapCellBehavior = GridWrapCellBehavior.WrapRow;
			DataTable parentTable = GetParentTable();			
			this.gridGroupingControl1.DataSource = parentTable;
			# endregion

			# region  [   Formatting GroupDrop Area   ]
			// TO SHOW DROP AREA [  Parent / Child / GrandChild / GreatGrandChild  ]
			this.gridGroupingControl1.ShowGroupDropArea = true;						
			this.gridGroupingControl1.AddGroupDropArea("ChildTable"); 
								
			this.gridGroupingControl1.Splitter.BackColor = Color.Red;				// SPLITTER COLOR
			this.gridGroupingControl1.GroupDropPanel.BackColor = Color.YellowGreen;	// PANEL COLOR
			this.gridGroupingControl1.GridGroupDropArea.Model.ColCount = 80;		// COLUMNS IN GRIDGROUPDROPAREA				
			this.gridGroupingControl1.GridGroupDropArea.Model.TableStyle.BackColor = Color.YellowGreen;
			
			foreach(Control ctl in this.gridGroupingControl1.GroupDropPanel.Controls)
			{
				GridGroupDropArea groupDropArea = ctl as GridGroupDropArea;
				SetStyleProperties(groupDropArea);  // To set style properties for each groupdroparea, In order set different style properties for each controls, you need to handle events for each control 
			}		
			# endregion
		}	

		# region     [   DataTable    ]
		private int numberParentRows = 10;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");
			
			dt.Columns.Add(new DataColumn("ParentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}		
		# endregion				
		
		# region   [   SetStyleProperties Method    ]
		void SetStyleProperties( GridGroupDropArea groupDropArea)
		{
			groupDropArea.DragColumnHeaderText = "Drop here the columns to Group records";       // To set the label text
			groupDropArea.Model.TableStyle.BackColor = Color.YellowGreen;
			groupDropArea.CellDrawn += new GridDrawCellEventHandler(groupDropArea_CellDrawn);    // To format the dropped column header in droparea  
			groupDropArea.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(groupDropArea_PrepareViewStyleInfo);		// to set the style properties to groupdroparea					
			groupDropArea.Model.QueryColWidth += new GridRowColSizeEventHandler(Model_QueryColWidth);
		}
		# endregion

		# region  [   PrepareViewStyleInfo event : To Set the Style Properties to GroupDropArea  ]
		private void groupDropArea_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{
			if (e.ColIndex == 2 && e.RowIndex == 2)
			{				
				e.Style.Font.Bold = true;
				e.Style.BackColor = Color.YellowGreen;
				e.Style.TextColor = Color.Blue;		
				e.Style.Text = "MyTable";
				e.Style.CellType = "Static";
				e.Style.HorizontalAlignment = GridHorizontalAlignment.Right;				
				e.Style.Enabled = false;
				e.Cancel = true;
			}
			else if (e.Style.Text.StartsWith("ParentName"))
			{
				e.Style.Text = "Syncfusion";
				e.Style.BackColor = Color.White;
			}	
			else if (e.RowIndex == 2  && e.ColIndex == 4)
			{				
				e.Style.HorizontalAlignment = GridHorizontalAlignment.Right;
				e.Style.BackColor = Color.White;				
			}						
		}
		# endregion

		# region   [   CellDrawn Event : To Format the ColumnHeaderCell Dropped in GroupDropArea  ]
		private void groupDropArea_CellDrawn(object sender, GridDrawCellEventArgs e)
		{
			if(e.Style.CellType == "ColumnHeaderCell")
			{					
				e.Graphics.FillRectangle(Brushes.Yellow,e.Bounds);    				
				e.Graphics.DrawString(e.Style.Text,e.Style.GdipFont,Brushes.Black,e.Bounds.X + 2f,e.Bounds.Y + 2f,StringFormat.GenericTypographic);           
			
				ListSortDirection listSortDirection = (ListSortDirection)e.Style.Tag ;
				Rectangle rect = new Rectangle (e.Bounds.X + e.Bounds.Width/3   , e.Bounds .Y ,e.Bounds.Width,e.Bounds.Height);//     e.Bounds; 
				int i2 = Math.Max(0, (rect.Height - 4) / 2);
				rect.Inflate(-i2, -i2);

				Pen pen1 = new Pen(SystemColors.WindowFrame);
				GridTriangleDirection triangleDirection = listSortDirection == ListSortDirection.Ascending ? GridTriangleDirection.Up : GridTriangleDirection.Down;
				GridPaintTriangle.Paint(e.Graphics , rect , triangleDirection, Brushes.Black , pen1, true);
				pen1.Dispose();				
				
				e.Cancel = true;
			}
		}
		#endregion

		# region [   QueryColWidth Event : To Set Column Width in GroupDropArea  ]
		private void Model_QueryColWidth(object sender, GridRowColSizeEventArgs e)
		{
			if(e.Index == 2 )
			{
				e.Size = 150;
				e.Handled = true;
			}
		}
		# endregion
	}
}
